package de.hdm_stuttgart.mi.sda1.saxhtml.v1;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

/** Parser, content- and error handler assembly */
public class Memo2Html  {

	private final XMLReader xmlReader;
	private final MyErrorHandler errorHandler = new MyErrorHandler();

	/**
	 * @param out
	 * @throws SAXException
	 *             Parsing may fail.
	 * @throws ParserConfigurationException
	 *             Unable to instantiate parser.
	 */
	public Memo2Html(final ContentHandler handler) throws SAXException,
			ParserConfigurationException {
		final SAXParserFactory saxPf = SAXParserFactory.newInstance();
		final SAXParser saxParser = saxPf.newSAXParser();
		xmlReader = saxParser.getXMLReader();

		xmlReader.setContentHandler(handler);
		xmlReader.setErrorHandler(errorHandler);
	}

	/**
	 * Parse an existing memo instance and create HTML output.
	 * 
	 * @param uri
	 *            The resource to be parsed
	 * @throws IOException
	 *             Access related problems
	 * @throws SAXException
	 *             Parsing may fail
	 */
	public void parse(final String uri) throws IOException, SAXException {
		xmlReader.parse(uri);
	}
}